import { BoostPowStringModel } from './boost-pow-string-model';
import { BoostPowJobModel } from './boost-pow-job-model';
import { BoostPowJobProofModel } from './boost-pow-job-proof-model';
import { BoostPowMetadataModel } from './boost-pow-metadata-model';
import { BoostUtils } from './boost-utils';
import { BoostSignalModel } from './boost-signal-model';
import { BoostSignalRankerModel } from './boost-signal-ranker-model';
import { GraphSearchQuery } from './graph-search-query';
export declare class BoostGraphClient {
    options: any;
    constructor(providedOptions?: any);
    get BoostPowString(): typeof BoostPowStringModel;
    get BoostPowJob(): typeof BoostPowJobModel;
    get BoostPowJobProof(): typeof BoostPowJobProofModel;
    get BoostPowMetadata(): typeof BoostPowMetadataModel;
    get BoostPowSignal(): typeof BoostSignalModel;
    get BoostUtilsHelper(): typeof BoostUtils;
    rawSearch(q?: GraphSearchQuery, callback?: Function): Promise<any>;
    search(q?: GraphSearchQuery, callback?: Function): Promise<any>;
    getBoostJobStatus(txid: string, callback?: Function): Promise<any>;
    submitBoostJob(rawtx: string, callback?: Function): Promise<any>;
    submitBoostSolution(params: {
        txid: string;
        vout: number;
        time: number;
        nonce: number;
        extraNonce1: number;
        extraNonce2: string;
    }, callback?: Function): Promise<any>;
    loadBoostJob(txid: string, callback?: Function): Promise<any>;
    getBoostJobUtxos(scriptHash: string, callback?: Function): Promise<any>;
    setOptions(newOptions: any): void;
    static instance(newOptions?: any): BoostGraphClient;
}
export declare function Graph(newOptions?: any): BoostGraphClient;
export declare function instance(newOptions?: any): BoostGraphClient;
export declare var BoostPowString: typeof BoostPowStringModel;
export declare var BoostPowJob: typeof BoostPowJobModel;
export declare var BoostPowJobProof: typeof BoostPowJobProofModel;
export declare var BoostPowMetadata: typeof BoostPowMetadataModel;
export declare var BoostUtilsHelper: typeof BoostUtils;
export declare var BoostGraph: typeof BoostGraphClient;
export declare var BoostSignal: typeof BoostSignalModel;
export declare var BoostSignalRanker: typeof BoostSignalRankerModel;
declare function searchGraph(q?: GraphSearchQuery, callback?: Function): Promise<any>;
declare function rawSearchGraph(q?: GraphSearchQuery, callback?: Function): Promise<any>;
export declare var search: typeof searchGraph;
export declare var rawSearch: typeof rawSearchGraph;
declare function submitBoostJobGraph(rawtx: string, callback?: Function): Promise<any>;
export declare var submitJob: typeof submitBoostJobGraph;
declare function getBoostJobStatusGraph(txid: string, callback?: Function): Promise<any>;
export declare var getJobStatus: typeof getBoostJobStatusGraph;
export {};
